' Programm TEST_IF.BAS
' Peter Grundmann, Hochstrae 13, 66564 Ottweiler
' testet die Kommunikation mit der GROUPIE-MEB-Tron,
' Datenbit1, Adrebit 1, write- und read-Leitung
' das Programm geht davon aus, dass die PIO-Karte von BMC
' auf der Standard-Adresse 210hex eingestellt ist

DEFINT A-Z
DIM SHARED PIOA AS INTEGER
DIM SHARED PIOB AS INTEGER
DIM SHARED PIOC AS INTEGER
DIM SHARED PIOCTRL AS INTEGER
'**********************************************************************
'* Falls die PIO-Karte auf eine andere Adresse als 210hex eingestellt *
'* ist mssen Sie die nachfolgende Zeile ndern                       *
'* wenn Sie die Adresse hexadezimal eintragen wollen mssen Sie '&H'  *
'* voranstellen.                                                      *
'* Bei dezimaler Eingabe kann der Vorsatz entfallen: Adresse=528      *
Adresse = &H210                                                      '*
'Adresse = &H314                                                      '*
'**********************************************************************

CLS

'alle Adressen der Pio-Karte vorbelegen
PIOA = Adresse
PIOB = Adresse + 1
PIOC = Adresse + 2
PIOCTRL = Adresse + 3

CLS
PRINT " Testprogramm fr das Interface zur GROUPIE-MEB-Tron"
PRINT
PRINT " Adresse der PIO-Karte ist dezimal"; Adresse;
PRINT
PRINT
PRINT " Ist die Interfacekarte der Steuerung mit dem PC verbunden?"
PRINT " Stecken Sie nur die Netzteilkarte und die Interfacekarte "
PRINT " in das Steuergert."
PRINT " Beobachten Sie dann die LED's 1 bis 4."
PRINT " dann bettigen Sie eine beliebige Taste."
PRINT " Schalten Sie dann das Steuergert ein und "
PRINT " bettigen eine beliebige Taste fr die einzelnen Schritte."
PRINT " Die <ESC>-Taste bricht das Programm ab."
'Tastaturpuffer leeren
DO
LOOP UNTIL INKEY$ = ""
DO
LOOP WHILE INKEY$ = ""

'Anzeigebereich auf Zeilen 15-23 einschrnken

VIEW PRINT 15 TO 23
Schritt = 1
DO
    'Hauptschleife
    CLS
    SELECT CASE Schritt
        CASE 1
            'Schritt 1: alle LED's
            PRINT " Die vier Leuchtdioden auf der Testkarte mssen jetzt alle leuchten."
            'Print Schritt
            OUT PIOCTRL, 136
            FOR KL = 1 TO 10000: NEXT
            OUT PIOA, 255
            FOR KL = 1 TO 10000: NEXT
            OUT PIOB, 255
            FOR KL = 1 TO 10000: NEXT
            OUT PIOC, 8
            FOR KL = 1 TO 10000: NEXT
        CASE 2
            'Nur D4 fr Adrebit 0
            CLS
            PRINT " Nur D4 fr Adrebit 0 darf leuchten."
            'Print Schritt
            OUT PIOCTRL, 136
            FOR KL = 1 TO 10000: NEXT
            OUT PIOA, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOB, 255
            FOR KL = 1 TO 10000: NEXT
            OUT PIOC, 14
            FOR KL = 1 TO 10000: NEXT
        CASE 3
            'Nur D1 fr Datenbit 0
            CLS
            PRINT " Nur D1 fr Datenbit 0 darf leuchten."
            'Print Schritt
            OUT PIOCTRL, 136
            FOR KL = 1 TO 10000: NEXT
            OUT PIOA, 255
            FOR KL = 1 TO 10000: NEXT
            OUT PIOB, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOC, 14
            FOR KL = 1 TO 10000: NEXT
        CASE 4
            'Nur D3 fr /Read
            CLS
            PRINT " Nur D3 fr /Read darf leuchten."
            'Print Schritt
            OUT PIOCTRL, 136
            FOR KL = 1 TO 10000: NEXT
            OUT PIOA, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOB, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOC, 12
            FOR KL = 1 TO 10000: NEXT
        CASE 5
            'Nur D2 fr /Write
            CLS
            PRINT " Nur D2 fr /Write darf leuchten."
            'Print Schritt
            OUT PIOCTRL, 136
            FOR KL = 1 TO 10000: NEXT
            OUT PIOA, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOB, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOC, 10
            FOR KL = 1 TO 10000: NEXT
        CASE 6
            'keine LED darf leuchten
            CLS
            PRINT " Keine LED darf leuchten."
            'Print Schritt
            OUT PIOCTRL, 136
            FOR KL = 1 TO 10000: NEXT
            OUT PIOA, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOB, 0
            FOR KL = 1 TO 10000: NEXT
            OUT PIOC, 14
            FOR KL = 1 TO 10000: NEXT
        CASE ELSE
    END SELECT
    DO
        Taste$ = INKEY$
    LOOP UNTIL Taste$ = ""

    DO
        Taste$ = INKEY$
    LOOP WHILE Taste$ = ""
    IF Taste$ = CHR$(27) THEN
        Schritt = 0
    ELSE
        IF Schritt < 6 THEN
            Schritt = Schritt + 1
        ELSE
            Schritt = 1
        END IF
    END IF
LOOP WHILE Schritt
VIEW PRINT
CLS
PRINT "Testprogramm beendet";
END

