' Programm T_IF_D.BAS
' Peter Grundmann, Hochstrae 13, 66564 Ottweiler
' testet die Kommunikation mit der GROUPIE-MEB-Tron,
' einzeln fr alle Datenbits
' das Programm geht davon aus, dass die PIO-Karte von BMC
' auf der Standard-Adresse 210hex eingestellt ist

DEFINT A-Z
DIM SHARED PIOA AS INTEGER
DIM SHARED PIOB AS INTEGER
DIM SHARED PIOC AS INTEGER
DIM SHARED PIOCTRL AS INTEGER
'**********************************************************************
'* Falls die PIO-Karte auf eine andere Adresse als 210hex eingestellt *
'* ist mssen Sie die nachfolgende Zeile ndern                       *
'* wenn Sie die Adresse hexadezimal eintragen wollen mssen Sie '&H'  *
'* voranstellen.                                                      *
'* Bei dezimaler Eingabe kann der Vorsatz entfallen: Adresse=528      *
Adresse = &H210                                                      '*
'**********************************************************************

CLS

'alle Adressen der Pio-Karte vorbelegen
PIOA = Adresse
PIOB = Adresse + 1
PIOC = Adresse + 2
PIOCTRL = Adresse + 3

CLS
PRINT " Testprogramm fr das Interface zur GROUPIE-MEB-Tron"
PRINT
PRINT " Adresse der PIO-Karte ist dezimal"; Adresse;
PRINT
PRINT
PRINT " Ist die Interfacekarte der Steuerung mit dem PC verbunden?"
PRINT " Stecken Sie nur die Netzteilkarte und die Interfacekarte "
PRINT " in das Steuergert."
PRINT " Beobachten Sie dann die einzelnen Datenbits an C3 bis C10 am Bus."
PRINT " dann bettigen Sie eine beliebige Taste."
PRINT " Schalten Sie dann das Steuergert ein. "
PRINT " Bettigen eine beliebige Taste fr die einzelnen Schritte."
PRINT " Die <ESC>-Taste bricht das Programm ab."
'Tastaurpuffer leeren
DO
LOOP UNTIL INKEY$ = ""
'Anzeigebereich auf Zeilen 15-23 einschrnken
DO
LOOP WHILE INKEY$ = ""


VIEW PRINT 15 TO 23
Schritt = 1
DO
    'Hauptschleife
    CLS
        'Ausgabe nur der Datenbits
        CLS
        PRINT " Nur Datenbit"; Schritt - 1; "darf aktiv sein."
        OUT PIOCTRL, 136
        OUT PIOA, 2 ^ (Schritt - 1)
        OUT PIOB, 0
        OUT PIOC, 14

    DO
        Taste$ = INKEY$
    LOOP UNTIL Taste$ = ""

    DO
        Taste$ = INKEY$
    LOOP WHILE Taste$ = ""
    IF Taste$ = CHR$(27) THEN
        Schritt = 0
    ELSE
        IF Schritt < 8 THEN
            Schritt = Schritt + 1
        ELSE
            Schritt = 1
        END IF
    END IF
LOOP WHILE Schritt
VIEW PRINT
CLS
PRINT "Testprogramm beendet";
END

